USE [COWS]
GO
_CreateObject 'SP','web','UpdateCalendarData'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =========================================================
-- Author:		jrg7298
-- Create date: 08/01/2012
-- Description:	Updates APPT table from ES or WF Calendar.
-- =========================================================
ALTER PROCEDURE [web].[UpdateCalendarData]
	@APPT_ID INT,
	@STRT_TMST SMALLDATETIME = NULL,
	@END_TMST SMALLDATETIME = NULL,
	@RCURNC_DES_TXT VARCHAR(2000) = NULL,
	@SUBJ_TXT VARCHAR(1000) = NULL,
	@DES VARCHAR(1000) = NULL,
	@APPT_LOC_TXT VARCHAR(500) = NULL,
	@APPT_TYPE_ID INT = NULL,
	@CREAT_BY_USER_ID INT = NULL,
	@MODFD_BY_USER_ID INT = NULL,
	@ASN_TO_USER_ID_LIST_TXT VARCHAR(MAX) = NULL,
	@RCURNC_CD BIT = NULL,
	@DELFLG	BIT
AS
BEGIN
SET NOCOUNT ON;
Begin Try
	
	IF (@DELFLG = 0)
	BEGIN	
		IF (@APPT_ID = -1)
		BEGIN
			INSERT INTO dbo.[APPT] ([SUBJ_TXT], [DES], [STRT_TMST], [END_TMST], [APPT_LOC_TXT], [APPT_TYPE_ID], [RCURNC_DES_TXT],[CREAT_BY_USER_ID],[CREAT_DT],[ASN_TO_USER_ID_LIST_TXT],[RCURNC_CD]) VALUES (REPLACE(REPLACE(@SUBJ_TXT,', Soft Assigned: False',''),', Soft Assigned: True',''), @DES, @STRT_TMST, @END_TMST, @APPT_LOC_TXT,  @APPT_TYPE_ID, @RCURNC_DES_TXT,@CREAT_BY_USER_ID,GETDATE(),@ASN_TO_USER_ID_LIST_TXT,@RCURNC_CD); 
			IF ((@RCURNC_CD = 1) AND (LEN(@RCURNC_DES_TXT) > 0))
				INSERT INTO dbo.APPT_RCURNC_TRGR (APPT_ID, STUS_ID, CREAT_DT) VALUES (SCOPE_IDENTITY(), 0, GETDATE())
		END
		ELSE
		BEGIN
			IF ((EXISTS (SELECT 'X'
					   FROM dbo.APPT WITH (NOLOCK)
					   WHERE APPT_ID = @APPT_ID
					     AND RCURNC_CD = 1)) AND (@RCURNC_CD = 0))
			BEGIN
				DELETE FROM dbo.APPT_RCURNC_TRGR WITH (ROWLOCK) WHERE [APPT_ID] = @APPT_ID; 
				DELETE FROM dbo.APPT_RCURNC_DATA WITH (ROWLOCK) WHERE [APPT_ID] = @APPT_ID; 
			END

			UPDATE dbo.[APPT] WITH (ROWLOCK) SET  [SUBJ_TXT] = REPLACE(REPLACE(@SUBJ_TXT,', Soft Assigned: False',''),', Soft Assigned: True',''), [DES] = @DES, [STRT_TMST] = @STRT_TMST, [END_TMST] = @END_TMST, [APPT_LOC_TXT] = @APPT_LOC_TXT,[APPT_TYPE_ID] = @APPT_TYPE_ID, [RCURNC_DES_TXT] = @RCURNC_DES_TXT,[ASN_TO_USER_ID_LIST_TXT]=@ASN_TO_USER_ID_LIST_TXT,[MODFD_BY_USER_ID]=@MODFD_BY_USER_ID,[RCURNC_CD]=@RCURNC_CD,[MODFD_DT]=GETDATE() WHERE [APPT_ID] = @APPT_ID; 
			IF ((@RCURNC_CD = 1) AND (LEN(@RCURNC_DES_TXT) > 0))
				INSERT INTO dbo.APPT_RCURNC_TRGR (APPT_ID, STUS_ID, CREAT_DT) VALUES (@APPT_ID, 0, GETDATE())
		END
	END
	ELSE
	BEGIN
		DELETE FROM dbo.APPT_RCURNC_TRGR WITH (ROWLOCK) WHERE [APPT_ID] = @APPT_ID; 
		DELETE FROM dbo.APPT_RCURNC_DATA WITH (ROWLOCK) WHERE [APPT_ID] = @APPT_ID; 
		DELETE FROM dbo.[APPT] WITH (ROWLOCK) WHERE [APPT_ID] = @APPT_ID
	END
	
End Try

Begin Catch
	EXEC dbo.insertErrorInfo
End Catch	
END